"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from gr4vy.types import BaseModel, Nullable, OptionalNullable, UNSET, UNSET_SENTINEL
from pydantic import model_serializer
from typing_extensions import NotRequired, TypedDict


class ThreeDSecureErrorTypedDict(TypedDict):
    code: NotRequired[Nullable[str]]
    r"""The error code."""
    description: NotRequired[Nullable[str]]
    r"""The error description."""
    detail: NotRequired[Nullable[str]]
    r"""Detail about the 3DS error."""
    component: NotRequired[Nullable[str]]
    r"""Code indicating the 3-D Secure component that identified the error."""


class ThreeDSecureError(BaseModel):
    code: OptionalNullable[str] = UNSET
    r"""The error code."""

    description: OptionalNullable[str] = UNSET
    r"""The error description."""

    detail: OptionalNullable[str] = UNSET
    r"""Detail about the 3DS error."""

    component: OptionalNullable[str] = UNSET
    r"""Code indicating the 3-D Secure component that identified the error."""

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["code", "description", "detail", "component"]
        nullable_fields = ["code", "description", "detail", "component"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in type(self).model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m
